; 
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;Q Beginn der verwendeten Interrupt Service Routinen ( ISR )
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
;
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;Q USART Transmit Complete Interrupt
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
; Mit RETI in der Vektorsprungtabelle ist es beim ATmega8L auch getan
;
;
_UTXCaddr:
; in   s_sreg,SREG           ;Statusregister sichern 

 

; out  SREG,s_sreg            ;Statusregister wiederherstellen
; reti                       ;Ruecksprung aus der Interrupt Service Routine     
;
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;Q Timer0 Overflow ISR ( Interrupt Service Routine )
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
_OVF0addr:
 in   s_sreg,SREG           ;Statusregister sichern 
;
;Tasterentprellung. Das Bit key.actuated ( Taster betaetigt & entprellt )
;wird nach dem Auswerten in der Hauptprogrammschleife rueckgesetzt.
;
 bst  key_reg,key.unactuated;Taster betaetigt & entprellt im T-Flag speichern 
 sbis KEY_PIN,key.bit       ;Taster unbetaetigt?
 rjmp _actuated             ;Nein => Taster betaetigt
 brts _counterrestore       ;Zaehler auf 4 ruecksetzen
 rjmp _count                ;Bis 3 Zaehlen
_actuated:
 brts _count                ;Weiter von 5 bis 8 zaehlen
_counterrestore:
 cbr  key_reg,$03           ;Zaehlerbits 1&0 ruecksetzen
_count:
 sbrs key_reg,key.actuated  ;Taster betaetigt entprellt?
 inc  key_reg   
;
;ProgrammLaufAnzeige-LED ( PLA-LED ) blinken lassen 
;
 sbrs flag_reg,pla.flg      ;PLA-Flag in der Mainschleife quitiert?...
 rjmp _exit_OVF0addr        ;...Nein => ISR verlassen

 inc  ovf0_zaehler          ;Overflowzaehler inkrementieren...
 sbrs ovf0_zaehler,#ovf0_zaehler;...bis 16 gezaehlt...
 rjmp _exit_OVF0addr        ;...Nein => ISR verlassen
 clr  ovf0_zaehler          ;Overflowzaehler ruecksetzen

 in   ib,PORTB              ;PortB einlesen...
 ldi  ia,1<<pla.led            ;...Programmlaufanzeige-LED Maske laden...
 eor  ib,ia                 ;...jetzt LED invertieren...
 out  PORTB,ib              ;...und PortB veraendert zurueckschreiben
;
;ISR verlassen
; 
_exit_OVF0addr:             ;Timer0 Overflow Interrupt verlassen
 cbr flag_reg,1<<pla.flg    ;Programmlaufanzeige-Flag quitieren

 out  SREG,s_sreg           ;Statusregister wiederherstellen

 reti                       ;Ruecksprung aus der Interrupt Service Routine     
;
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;Two-wire Serial Interface ISR ( Interrupt Service Routine )
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
_TWIaddr:
 in   s_sreg,SREG           ;CPU-Statusregister sichern 

 in   ia,TWSR               ;TWI-Statusregister lesen
 andi ia,$F8                ;Nichtrelevante Bits ausmaskieren
 
 
 cpi  ia,#rm_twi_start      ;Wurde die Startbedingung gesendet?...
 brne _twi_error            ;Nein => Fehlerbehandlung noetig
 
 out  UDR,ia                ;Testweise gucken was in TWSR steht
  
 cbi  LED_PORT,led.ok       ;Testweise OK-LED einschalten

 rjmp _exit_twiaddr         ;Interrupt Service Routine ( ISR ) verlassen

_twi_error:
 ;sbi  LED_PORT,led.ok       ;Testweise OK-LED ausschalten

 in   ia,TWCR               ;Testweise gucken, was das TWINT-Flag...
 out  UDR,ia                ;...macht.

_exit_twiaddr:
 in  ia,TWCR                ;TWI-Kontroll Register lesen und dort das..
 ori ia,1<<TWINT            ;..TWI-Interrupt-Flag loeschen um erneute IRQ's..
 out TWCR,ia                ;.. zu ermoeglichen bzw. zu zulassen.

 cbr  key_reg,1<<key.actuated;Tasterbetaetigung quitieren
 
 out  SREG,s_sreg           ;CPU-Statusregister wiederherstellen;

 reti                       ;Ruecksprung aus der Interrupt Service Routine     